#COMPILE EXE              
#DIM ALL                            
#INCLUDE "WIN32API.INC"
'#INCLUDE "COMMCTRL.INC"
'#INCLUDE "calendarYrAPI.inc"
'#INCLUDE "debug.inc"
#RESOURCE "calendarYr.pbr"

%IDC_Buddy   = 101
%IDC_UpDown  = 102
%IDC_Prnt    = 103
%IDC_Focus   = 104
%MaxSpin     = 9999
%MinSpin     = 1000
%UPDOWNSTYLE = %WS_CHILD OR %WS_BORDER OR %WS_VISIBLE OR %UDS_ARROWKEYS _
               OR %UDS_ALIGNRIGHT OR %UDS_SETBUDDYINT OR %UDS_NOTHOUSANDS

GLOBAL hCal, hdc, hBit AS LONG
GLOBAL hFont, hFont1, hOrigFont, hhFont, hhFont1 AS LONG
GLOBAL xWeek, xChr, yChr AS DOUBLE

SUB calendar
   DIALOG NEW PIXELS, 0, "Full Year Calendar", 10, 10, 470, 370, %WS_SYSMENU TO hCal
   CONTROL ADD TEXTBOX, hCal, %IDC_Buddy, "", 285, 10, 75, 25  ', %ES_NUMBER, %WS_EX_CLIENTEDGE
   CONTROL ADD "msctls_updown32", hCal, %IDC_UpDown, "", 0, 0, 8, 8, %UPDOWNSTYLE
   CONTROL SEND hCal, %IDC_UpDown, %UDM_SETBUDDY, GetDlgItem(hCal, %IDC_Buddy), 0
   CONTROL SEND hCal, %IDC_UpDown, %UDM_SETRANGE, 0&, MAKLNG(%MaxSpin, %MinSpin)
   CONTROL ADD BUTTON, hCal, %IDC_Prnt, "&Print calendar", 400, 5, 100, 30
   CONTROL ADD BUTTON, hCal, %IDC_Focus, "", 0, 0, 0, 0
   DIALOG SET COLOR hCal, -1, %WHITE
   DIALOG SHOW MODAL hCal CALL calendarProc
END SUB

CALLBACK FUNCTION calendarProc
   LOCAL k, n, nPos AS LONG, ps AS PAINTSTRUCT
   LOCAL s, c AS STRING
   STATIC year, prn AS LONG, yr AS STRING
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG
         yr = RIGHT$(DATE$, 4): year = VAL(yr)
         CONTROL SET TEXT CBHNDL, %IDC_Buddy, yr
         prn = -1: CONTROL SET FOCUS CBHNDL, %IDC_Buddy
      CASE %WM_PAINT
         BeginPaint CBHNDL, ps
         showMonths year, prn
         EndPaint CBHNDL, ps
      case %WM_ACTIVATE
         InvalidateRect cb.hndl, byval %NULL, 0
      CASE %WM_COMMAND
         IF CBCTL = %IDC_Buddy AND CBCTLMSG = %EN_UPDATE THEN
            CONTROL GET TEXT CBHNDL, %IDC_Buddy TO s   'get current text for filtering
            CONTROL SEND CBHNDL, %IDC_Buddy, %EM_GETSEL, VARPTR(nPos), VARPTR(k) 'get pos
            k = ASC(s, nPos)
            IF k > 0 THEN
               c = CHR$(k): n = INSTR("1234567890", CHR$(k))
               IF n = 0 THEN 'not valid character
                  s = LEFT$(s, nPos - 1) + MID$(s, nPos + 1): DECR nPos
               END IF
               CONTROL SET TEXT CBHNDL, %IDC_Buddy, s               
               CONTROL SEND CBHNDL, %IDC_Buddy, %EM_SETSEL, nPos, nPos
            END IF
            IF LEN(s) < 4 OR LEN(s) > 4 THEN EXIT FUNCTION
            prn = 0
            year = VAL(s)
            showMonths year, prn: reDrawRgns
            CONTROL SET FOCUS CBHNDL, %IDC_Focus
         ELSEIF CBCTL = %IDC_Prnt AND CBCTLMSG = %BN_CLICKED THEN
            prn = 1: showMonths year, prn: prn = 0
         ELSEIF CBCTL = %IDCANCEL THEN
            CONTROL GET TEXT CBHNDL, %IDC_Buddy TO s
            IF s = yr THEN DIALOG END CBHNDL
            CONTROL SET TEXT CBHNDL, %IDC_Buddy, yr
            year = VAL(yr): showMonths year, prn: reDrawRgns
         END IF
      CASE %WM_DESTROY
         SelectObject hdc, hOrigFont
         DeleteObject hFont
         DeleteObject hFont1
         ReleaseDC hCal, hdc
   END SELECT
END FUNCTION

SUB reDrawRgns()
   LOCAL i, j, m, n, mm, nn, top AS LONG, r AS RECT
   top = 50 'top of calendar months
   FOR j = 0 TO 2
      FOR i = 0 TO 3
         m = 10.6*yChr*j: n = 25.7*xChr*i
         mm = top + 2.85*yChr + m: nn = xChr + n
         r.nTop = mm + 1: r.nLeft = nn - xChr:
         r.nRight = r.nLeft + 22*xChr: r.nBottom = r.nTop + 8*yChr
         InvalidateRect hCal, r, 1
      NEXT i
   NEXT j
END SUB

SUB showMonths(yr AS LONG, prn AS LONG)
   'prn < 0  initialize hdc, bitmap for today, and two fonts
   '         show month and weekday headings one time, not each year
   '    = 0  display calendar for year yr
   '    > 0  print calendar for year yr
   LOCAL memdc, i, j, k, m, n, mm, nn, ii, startDay, days, mo, found AS LONG
   LOCAL today, thisMo, thisYr, ppix, ppiy, nLeft, nTop, top, week AS LONG
   LOCAL s, ss AS STRING, t AS SIZEL, sz AS ASCIIZ * 128
   LOCAL x, y, x1, y1, u, v AS SINGLE
   STATIC ti AS STRING
   
   DIM months(12) AS STRING
   months(1) = "January" : months(2) = "February" : months(3) = "March"
   months(4) = "April"   : months(5) = "May"      : months(6) = "June"
   months(7) = "July"    : months(8) = "August"   : months(9) = "September"
   months(10)= "October" : months(11)= "November" : months(12)= "December"
   today = VAL(MID$(DATE$, 4, 2))
   thisMo = VAL(LEFT$(DATE$, 2))
   thisYr = VAL(RIGHT$(DATE$, 4))
   top = 50 'top of calendar months
   IF prn < 0 THEN
      hdc = GetDC(hCal)                                
      hBit = LoadBitmap(GetModuleHandle(BYVAL %NULL), "TodayBitMap")
      hFont1 = makeFont(hdc, "MS Sans Serif", 10, "b")
      hFont = makeFont(hdc, "Courier New", 9)
      hOrigFont = SelectObject(hdc, hFont)
      ti = "Su Mo Tu We Th Fr Sa": sz = ti
      GetTextExtentPoint32 hdc, sz, LEN(sz), t                                            
      xWeek = t.cx
      xChr = xWeek/LEN(ti): yChr = t.cy
      DIALOG SET CLIENT hCal, 100*xChr, 36*yChr
   ELSEIF prn > 0 THEN
      nLeft = 60: nTop = 40
      FONT NEW "Courier New", 9 TO hhFont
      FONT NEW "MS Sans Serif", 10 TO hhFont1
      XPRINT ATTACH CHOOSE
      XPRINT GET PPI TO ppix, ppiy
      u = 6.5 * ppix / 600: v = 5 * ppiy / 600
      XPRINT SET ORIENTATION 2
      'XPRINT FONT "MS Sans Serif", 10
      XPRINT SET POS (u * (nLeft + 7), v * (nTop + top))
      XPRINT TRIM$(STR$(yr)) + " Calendar"
   END IF
   FOR j = 0 TO 2                                                                  
   FOR i = 0 TO 3
      'm = 170 * j: n = 180 * i: INCR mo
      'm = 10.6*yChr*j: n = 22.5*xChr*i: INCR mo
      m = 10.6*yChr*j: n = 25.7*xChr*i: INCR mo
      s = months(mo): sz = s
      GetTextExtentPoint32 hdc, sz, LEN(sz), t
      IF prn < 0 THEN
         SelectObject hdc, hFont1
         sz = months(mo)
         GetTextExtentPoint32 hdc, sz, LEN(sz), t
         x = xChr + n + (xWeek-t.cx)/2
         y = top + 10 + m
         textout hdc, x, y, sz, LEN(sz)  'show month
      ELSEIF prn > 0 THEN
         XPRINT SET FONT hhFont1
         x = u * (nLeft + 75 + n - (t.cx)/2): y = v *(nTop + top + 50 + m)
         XPRINT SET POS (x, y)
         XPRINT s
      END IF
   NEXT i
   NEXT j
   SelectObject(hdc, hFont): mo = 0
   FOR j = 0 TO 2
   FOR i = 0 TO 3
      m = 10.6*yChr*j: n = 25.7*xChr*i: INCR mo
      IF prn < 0 THEN
         sz = ti   'show Su Mo Tu We Th Fr Sa
         textout hdc, xChr + n, top + 2*yChr + m, sz, LEN(sz)
         MoveToEx hDC, xChr + n, top + 2.85*yChr + m, BYVAL %NULL 'draw horiz line
         LineTo hDC, 21*xChr + n, top + 2.85*yChr + m
         IF i < 3 THEN 'draw vert lines
            MoveToEx hDC, 24*xChr + n, top + yChr + m, BYVAL %NULL
            LineTo hDC, 24*xChr + n, top + 10.5*yChr + m
         END IF
      ELSEIF prn > 0 THEN
         XPRINT SET FONT hhFont
         x = u * (nLeft + 7 + n): y = v * (nTop + top + 70 + m)
         XPRINT SET POS (x, y)
         XPRINT ti
         x = u * (nLeft + 7 + n): y = v * (nTop + top + 85 + m)
         x1 = u * (nLeft + 150 + n): y1 = y
         XPRINT LINE (x, y) - (x1, y1)
         IF i < 3 THEN
            x = u * (nLeft + 170 + n): y = v * (ntop + top + 50 + m)
            x1 = x: y1 = v * (nTop + top + 195 + m)
            XPRINT LINE (x, y) - (x1, y1)
         END IF
      END IF
                                                                      
      startDay = dayOfWeek(mo, yr, 1)                                      
      days = daysInMonth(mo, yr)                                       
      m = 0: n = startDay: 's = SPACE$(3 * n)
      s = "": for ii = 1 to n: s = s + "   ": next ii
      FOR k = 1 TO days
         s = s + RIGHT$("  " + STR$(k), 3) 'show week at a time
         sz = MID$(s, 2): replace "z" with " " in sz: INCR n
         IF n = 7 OR k = days THEN
            INCR m: nn = xChr + 25.7*xChr*i: mm = top+2*yChr + 10.6*yChr*j + 1.2*yChr*m
            textout hdc, nn, mm, sz, LEN(sz)
            IF prn > 0 THEN
               XPRINT SET POS (u * (nLeft + nn), v * (nTop + 40 + mm)): XPRINT MID$(s, 2)      
            END IF
            IF found = 0 AND mo = thisMo AND yr = thisYr THEN 'circle today in red
               REDIM week(0 TO 7) AS STRING
               REPLACE "  " WITH " " IN s
               PARSE s, week(), ANY " "
               FOR ii = 1 TO 7
                  IF VAL(week(ii)) = today THEN found = ii: EXIT FOR
               NEXT ii
               IF found THEN
                  memdc = CreateCompatibleDC(hdc)
                  SelectObject memdc, hBit
                  nn = nn + (found-1)*3*xChr
                  BitBlt hdc, nn-3, mm-4, 4*xChr, 2*yChr, memdc, 0, 0, %SRCAND
                  DeleteDC memdc
               END IF
            END IF
            n = 0: s = ""
         END IF
      NEXT k                                 
   NEXT i
   NEXT j
   hOrigFont = SelectObject(hdc, hFont1)
   sz = TRIM$(STR$(yr)) + " Calendar"
   textout hdc, xChr, yChr, sz, LEN(sz)
   IF prn > 0 THEN XPRINT CLOSE
END SUB

FUNCTION dayOfWeek(month AS LONG, year AS LONG, day AS LONG) AS LONG
   'The AstroDay function defined here is a modified version of the Julian date formula used by astronomers.
   'http://support.microsoft.com/kb/q109451/
   'Sun = 0, Mon = 1, Tue = 2, ...
   LOCAL astroDay AS LONG, y AS DOUBLE
   y = year + (month - 2.85) / 12
   astroDay = INT(INT(INT(367*y)-1.75*INT(y)+day) -0.75*INT(0.01*y))+1721119
   FUNCTION = (astroDay - 3) MOD 7
END FUNCTION

FUNCTION daysInMonth(mo AS LONG, yr AS LONG) AS LONG
   LOCAL days AS INTEGER
   IF mo < 8 THEN
      days = 30 + mo MOD 2
   ELSE
      days = 30 + (mo + 1) MOD 2
   END IF
   IF mo = 2 THEN
      days = 28
      IF (yr MOD 100 <> 0 OR yr MOD 400 = 0) _
         AND yr MOD 4 = 0 THEN INCR days 'leap yr
   END IF
   daysInMonth = days
END FUNCTION

FUNCTION MakeFont(hDC AS LONG, sFont AS STRING, BYVAL ptSize AS LONG, _
                  OPT BYVAL descr AS STRING) AS LONG
   'specify descr = b for bold, u for underline, i for italic
   LOCAL CyPixels AS LONG, charHt AS LONG, wt AS DWORD
   LOCAL BOLD AS DWORD, underline AS DWORD, italic AS DWORD
   IF LEN(descr) THEN
      BOLD = INSTR(descr, "b") + 300
      underline = INSTR(descr,"u")
      italic = INSTR(descr,"i")
   END IF
   CyPixels  = GetDeviceCaps(hDC, %LOGPIXELSY)
   charHt = (PtSize * CyPixels) \ 72
   wt = %FW_NORMAL + BOLD
   FUNCTION = CreateFont(-charHt, 0, 0, 0, wt, italic, underline, 0, _
              %ANSI_CHARSET, %OUT_TT_PRECIS, %CLIP_DEFAULT_PRECIS, _
              %DEFAULT_QUALITY, %FF_DONTCARE, BYCOPY sFont)
END FUNCTION

FUNCTION PBMAIN()
   calendar
END FUNCTION
